import java.io.Serializable;
import javax.persistence.*;



@Entity
@IdClass(MergeTest.ID.class)
public class MergeTest implements Serializable {

    public static void main(String[] args) {
        EntityManagerFactory emf =
            Persistence.createEntityManagerFactory("objectdb:test.tmp;drop");
        EntityManager em = emf.createEntityManager();
 
        MergeTest ph = new MergeTest("Hello", "World");

        em.getTransaction().begin();
        if (args.length>0) em.persist( ph );
        ph = em.merge(ph);
        em.getTransaction().commit();

        System.out.println( ph );

        em.close();
        emf.close();
    }


    @Id
    String s1;
    @Id
    long n;
    String s2;


    public MergeTest() {
    }

    public MergeTest(String s1) {
        this.s1 = s1;
    }

    public MergeTest(String s1, long ll) {
        this.s1 = s1;
        this.n = ll;
    }

    public MergeTest(String s1, String s2) {
        this.s1 = s1;
        this.s2 = s2;
    }


    public String toString() { return s1+n; }

    public static class ID implements Serializable {
        public long n;
        public String s1;

        public ID() {
        }

        public ID(int n, String s1) {
            this.n = n;
            this.s1 = s1;
        }

        public boolean equals(Object other) {
            if (other instanceof ID) {
                final ID otherID = (ID) other;
                return otherID.n == this.n && otherID.s1.equals(s1);
            }
            return false;
        }

        public int hashCode() {
            return (int)this.n + this.s1.hashCode();
        }
    }
}
